diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.43/src/wifi/test/wifi-phy-ofdma-test.cc	2024-10-09 16:41:10.140657000 -0700
+++ ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc	2025-03-09 16:55:49.811372800 -0700
@@ -3045,18 +3050,18 @@
 
     /**
      * Check the received power for the non-OFDMA of the HE TB PPDUs over the given band
-     * \param phy the PHY
-     * \param band the indices of the band over which the power is measured
-     * \param expectedRxPower the expected received power
+     * @param phy the PHY
+     * @param band the indices of the band over which the power is measured
+     * @param expectedRxPower the expected received power
      */
     void CheckNonOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
                               WifiSpectrumBandInfo band,
                               Watt_u expectedRxPower);
     /**
      * Check the received power for the OFDMA part of the HE TB PPDUs over the given band
-     * \param phy the PHY
-     * \param band the indices of the band over which the power is measured
-     * \param expectedRxPower the expected received power
+     * @param phy the PHY
+     * @param band the indices of the band over which the power is measured
+     * @param expectedRxPower the expected received power
      */
     void CheckOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
                            WifiSpectrumBandInfo band,
@@ -3069,26 +3074,26 @@
 
     /**
      * Check the PHY state
-     * \param phy the PHY
-     * \param expectedState the expected state of the PHY
+     * @param phy the PHY
+     * @param expectedState the expected state of the PHY
      */
     void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
-    /// \copydoc CheckPhyState
+    /// @copydoc CheckPhyState
     void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
 
     /**
      * Check the the number of RX start notifications at the AP as well as the last time a RX start
      * has been notified
-     * \param expectedNotifications the expected number of RX start notifications at the AP
-     * \param expectedLastNotification the expected time of the last RX start notification at the AP
+     * @param expectedNotifications the expected number of RX start notifications at the AP
+     * @param expectedLastNotification the expected time of the last RX start notification at the AP
      */
     void CheckApRxStart(uint32_t expectedNotifications, Time expectedLastNotification);
     /**
      * Check the the number of RX end notifications at the AP as well as the last time a RX end has
      * been notified
-     * \param expectedNotifications the expected number of RX end notifications at the AP
-     * \param expectedLastNotification the expected time of the last RX end notification at the AP
-     * \param expectedSuccess true if the last RX notification indicates a success, false otherwise
+     * @param expectedNotifications the expected number of RX end notifications at the AP
+     * @param expectedLastNotification the expected time of the last RX end notification at the AP
+     * @param expectedSuccess true if the last RX notification indicates a success, false otherwise
      */
     void CheckApRxEnd(uint32_t expectedNotifications,
                       Time expectedLastNotification,
@@ -3101,19 +3106,19 @@
 
     /**
      * Receive success function
-     * \param psdu the PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector the transmit vector
-     * \param statusPerMpdu reception status per MPDU
+     * @param psdu the PSDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector the transmit vector
+     * @param statusPerMpdu reception status per MPDU
      */
     void RxSuccess(Ptr<const WifiPsdu> psdu,
                    RxSignalInfo rxSignalInfo,
-                   WifiTxVector txVector,
-                   std::vector<bool> statusPerMpdu);
+                   const WifiTxVector& txVector,
+                   const std::vector<bool>& statusPerMpdu);
 
     /**
      * Receive failure function
-     * \param psdu the PSDU
+     * @param psdu the PSDU
      */
     void RxFailure(Ptr<const WifiPsdu> psdu);
 
@@ -3121,21 +3126,21 @@
      * Schedule test to perform.
      * The interference generation should be scheduled apart.
      *
-     * \param delay the reference delay to schedule the events
-     * \param solicited flag indicating if HE TB PPDUs were solicited by the AP
-     * \param expectedStateAtEnd the expected state of the PHY at the end of the reception
-     * \param expectedSuccessFromSta1 the expected number of success from STA 1
-     * \param expectedFailuresFromSta1 the expected number of failures from STA 1
-     * \param expectedBytesFromSta1 the expected number of bytes from STA 1
-     * \param expectedSuccessFromSta2 the expected number of success from STA 2
-     * \param expectedFailuresFromSta2 the expected number of failures from STA 2
-     * \param expectedBytesFromSta2 the expected number of bytes from STA 2
-     * \param scheduleTxSta1 flag indicating to schedule a HE TB PPDU from STA 1
-     * \param ulTimeDifference delay between HE TB PPDU from STA 1 and HE TB PPDU from STA 2
+     * @param delay the reference delay to schedule the events
+     * @param solicited flag indicating if HE TB PPDUs were solicited by the AP
+     * @param expectedStateAtEnd the expected state of the PHY at the end of the reception
+     * @param expectedSuccessFromSta1 the expected number of success from STA 1
+     * @param expectedFailuresFromSta1 the expected number of failures from STA 1
+     * @param expectedBytesFromSta1 the expected number of bytes from STA 1
+     * @param expectedSuccessFromSta2 the expected number of success from STA 2
+     * @param expectedFailuresFromSta2 the expected number of failures from STA 2
+     * @param expectedBytesFromSta2 the expected number of bytes from STA 2
+     * @param scheduleTxSta1 flag indicating to schedule a HE TB PPDU from STA 1
+     * @param ulTimeDifference delay between HE TB PPDU from STA 1 and HE TB PPDU from STA 2
      * are received
-     * \param expectedStateBeforeEnd the expected state of the PHY before the end of the
+     * @param expectedStateBeforeEnd the expected state of the PHY before the end of the
      * transmission
-     * \param error the erroneous info (if any) in the TRIGVECTOR to set
+     * @param error the erroneous info (if any) in the TRIGVECTOR to set
      */
     void ScheduleTest(Time delay,
                       bool solicited,
@@ -3154,11 +3159,11 @@
     /**
      * Schedule power measurement related checks.
      *
-     * \param delay the reference delay used to schedule the events
-     * \param rxPowerNonOfdmaRu1 the received power on the non-OFDMA part of RU1
-     * \param rxPowerNonOfdmaRu2 the received power on the non-OFDMA part of RU2
-     * \param rxPowerOfdmaRu1 the received power on RU1
-     * \param rxPowerOfdmaRu2 the received power on RU2
+     * @param delay the reference delay used to schedule the events
+     * @param rxPowerNonOfdmaRu1 the received power on the non-OFDMA part of RU1
+     * @param rxPowerNonOfdmaRu2 the received power on the non-OFDMA part of RU2
+     * @param rxPowerOfdmaRu1 the received power on RU1
+     * @param rxPowerOfdmaRu2 the received power on RU2
      */
     void SchedulePowerMeasurementChecks(Time delay,
                                         Watt_u rxPowerNonOfdmaRu1,
@@ -3168,7 +3173,7 @@
     /**
      * Log scenario description
      *
-     * \param log the scenario description to add to log
+     * @param log the scenario description to add to log
      */
     void LogScenario(std::string log) const;
 
@@ -3282,19 +3287,19 @@
                           bssColor};
 
     auto ruType = HeRu::RU_106_TONE;
-    if (m_channelWidth == 20)
+    if (m_channelWidth == MHz_u{20})
     {
         ruType = HeRu::RU_106_TONE;
     }
-    else if (m_channelWidth == 40)
+    else if (m_channelWidth == MHz_u{40})
     {
         ruType = HeRu::RU_242_TONE;
     }
-    else if (m_channelWidth == 80)
+    else if (m_channelWidth == MHz_u{80})
     {
         ruType = HeRu::RU_484_TONE;
     }
-    else if (m_channelWidth == 160)
+    else if (m_channelWidth == MHz_u{160})
     {
         ruType = HeRu::RU_996_TONE;
     }
@@ -3304,7 +3309,7 @@
     }
 
     auto primary80MHz = true;
-    if (m_channelWidth == 160 && index == 2)
+    if (m_channelWidth == MHz_u{160} && index == 2)
     {
         primary80MHz = false;
         index = 1;
@@ -3322,7 +3327,7 @@
     auto channelWidth = m_channelWidth;
     if (error == CHANNEL_WIDTH)
     {
-        channelWidth = (channelWidth == 160 ? 20 : channelWidth * 2);
+        channelWidth = (channelWidth == MHz_u{160} ? MHz_u{20} : channelWidth * 2);
     }
 
     WifiTxVector txVector(HePhy::GetHeMcs7(),
@@ -3339,19 +3344,19 @@
                           bssColor);
 
     HeRu::RuType ruType = HeRu::RU_106_TONE;
-    if (channelWidth == 20)
+    if (channelWidth == MHz_u{20})
     {
         ruType = HeRu::RU_106_TONE;
     }
-    else if (channelWidth == 40)
+    else if (channelWidth == MHz_u{40})
     {
         ruType = HeRu::RU_242_TONE;
     }
-    else if (channelWidth == 80)
+    else if (channelWidth == MHz_u{80})
     {
         ruType = HeRu::RU_484_TONE;
     }
-    else if (channelWidth == 160)
+    else if (channelWidth == MHz_u{160})
     {
         ruType = HeRu::RU_996_TONE;
     }
@@ -3368,7 +3373,7 @@
     txVector.SetMode(HePhy::GetHeMcs7(), aid1);
     txVector.SetNss(1, aid1);
 
-    HeRu::RuSpec ru2(ruType, (channelWidth == 160 ? 1 : 2), (channelWidth != 160));
+    HeRu::RuSpec ru2(ruType, (channelWidth == MHz_u{160} ? 1 : 2), (channelWidth != MHz_u{160}));
     txVector.SetRu(ru2, aid2);
     txVector.SetMode(HePhy::GetHeMcs7(), aid2);
     txVector.SetNss(1, aid2);
@@ -3430,8 +3435,10 @@
         phy = m_phySta3;
     }
 
-    Time txDuration =
-        phy->CalculateTxDuration(psdu->GetSize(), txVector, phy->GetPhyBand(), txStaId);
+    Time txDuration = OfdmaSpectrumWifiPhy::CalculateTxDuration(psdu->GetSize(),
+                                                                txVector,
+                                                                phy->GetPhyBand(),
+                                                                txStaId);
     txVector.SetLength(
         HePhy::ConvertHeTbPpduDurationToLSigLength(txDuration, txVector, phy->GetPhyBand()).first);
 
@@ -3462,8 +3469,8 @@
 void
 TestUlOfdmaPhyTransmission::RxSuccess(Ptr<const WifiPsdu> psdu,
                                       RxSignalInfo rxSignalInfo,
-                                      WifiTxVector txVector,
-                                      std::vector<bool> /*statusPerMpdu*/)
+                                      const WifiTxVector& txVector,
+                                      const std::vector<bool>& /*statusPerMpdu*/)
 {
     NS_LOG_FUNCTION(this << *psdu << psdu->GetAddr2() << rxSignalInfo << txVector);
     if (psdu->GetAddr2() == Mac48Address("00:00:00:00:00:01"))
@@ -3538,7 +3545,7 @@
     // Since there is out of band emission due to spectrum mask, the tolerance cannot be very low
     NS_TEST_ASSERT_MSG_EQ_TOL(rxPower,
                               expectedRxPower,
-                              5e-3,
+                              Watt_u{5e-3},
                               "RX power " << rxPower << " over (" << band
                                           << ") does not match expected power " << expectedRxPower
                                           << " at " << Simulator::Now());
@@ -3555,8 +3562,8 @@
      * duration when calling GetEnergyDuration.
      */
     NS_LOG_FUNCTION(this << band << expectedRxPower);
-    double step = 5e-3;
-    if (expectedRxPower > 0.0)
+    Watt_u step{5e-3};
+    if (expectedRxPower > Watt_u{0.0})
     {
         NS_TEST_ASSERT_MSG_EQ(
             phy->GetEnergyDuration(expectedRxPower - step, band).IsStrictlyPositive(),
@@ -4061,7 +4068,7 @@
                             rxPowerOfdma[i]);
     }
 
-    if (rxPowerOfdmaRu1 != 0.0)
+    if (rxPowerOfdmaRu1 != Watt_u{0.0})
     {
         /**
          * Perform checks for transmitting STA (STA 2) to ensure it has correctly logged
@@ -4069,7 +4076,7 @@
          * Cannot use CheckNonOfdmaRxPower method since current event not set.
          */
         const auto rxPowerNonOfdmaSta1Only =
-            (m_channelWidth >= 40)
+            (m_channelWidth >= MHz_u{40})
                 ? rxPowerNonOfdma[0]
                 : rxPowerNonOfdma[0] / 2; // both STAs transmit over the same 20 MHz channel
         // Check received power on non-OFDMA portion
@@ -4132,9 +4139,9 @@
     m_phySta3->SetOperatingChannel(
         WifiPhy::ChannelTuple{channelNum, m_channelWidth, WIFI_PHY_BAND_5GHZ, 0});
 
-    Time delay = Seconds(0.0);
+    Time delay;
     Simulator::Schedule(delay, &TestUlOfdmaPhyTransmission::Reset, this);
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     /**
      * In all the following tests, 2 HE TB PPDUs of the same UL MU transmission
@@ -4159,7 +4166,7 @@
                  1,
                  0,
                  1001); // One PSDU of 1001 bytes should have been successfully received from STA 2
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Verify that two solicited HE TB PPDUs with delay (< 400ns) between the two signals have been
@@ -4180,7 +4187,7 @@
                  1001, // One PSDU of 1001 bytes should have been successfully received from STA 2
                  true,
                  NanoSeconds(100));
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Verify that no unsolicited HE TB PPDU is received
@@ -4200,7 +4207,7 @@
                  true,
                  Seconds(0),
                  WifiPhyState::CCA_BUSY);
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Verify that HE TB PPDUs with channel width differing from TRIGVECTOR are discarded
@@ -4221,7 +4228,7 @@
                  Seconds(0),
                  WifiPhyState::CCA_BUSY,
                  CHANNEL_WIDTH);
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Verify that HE TB PPDUs with UL Length differing from TRIGVECTOR are discarded
@@ -4242,7 +4249,7 @@
                  Seconds(0),
                  WifiPhyState::CCA_BUSY,
                  UL_LENGTH);
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Verify that HE TB PPDUs with AIDs differing from TRIGVECTOR are discarded
@@ -4263,7 +4270,7 @@
                  Seconds(0),
                  WifiPhyState::CCA_BUSY,
                  AID);
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Generate an interference on RU 1 and verify that only STA 1's solicited HE TB PPDU has been
@@ -4275,16 +4282,16 @@
         "Reception of solicited HE TB PPDUs with interference on RU 1 during PSDU reception");
     // A strong non-wifi interference is generated on RU 1 during PSDU reception
     BandInfo bandInfo;
-    bandInfo.fc = (m_frequency - (m_channelWidth / 4)) * 1e6;
-    bandInfo.fl = bandInfo.fc - ((m_channelWidth / 4) * 1e6);
-    bandInfo.fh = bandInfo.fc + ((m_channelWidth / 4) * 1e6);
+    bandInfo.fc = MHzToHz(m_frequency - (m_channelWidth / 4));
+    bandInfo.fl = bandInfo.fc - MHzToHz(m_channelWidth / 4);
+    bandInfo.fh = bandInfo.fc + MHzToHz(m_channelWidth / 4);
     Bands bands;
     bands.push_back(bandInfo);
 
     Ptr<SpectrumModel> SpectrumInterferenceRu1 = Create<SpectrumModel>(bands);
     Ptr<SpectrumValue> interferencePsdRu1 = Create<SpectrumValue>(SpectrumInterferenceRu1);
     Watt_u interferencePower{0.1};
-    *interferencePsdRu1 = interferencePower / ((m_channelWidth / 2) * 20e6);
+    *interferencePsdRu1 = interferencePower / (MHzToHz(m_channelWidth / 2) * 20);
 
     Simulator::Schedule(delay + MicroSeconds(50),
                         &TestUlOfdmaPhyTransmission::GenerateInterference,
@@ -4302,7 +4309,7 @@
         1,
         0,
         1001); // One PSDU of 1001 bytes should have been successfully received from STA 2
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Generate an interference on RU 2 and verify that only STA 2's solicited HE TB PPDU has been
@@ -4313,15 +4320,15 @@
         this,
         "Reception of solicited HE TB PPDUs with interference on RU 2 during PSDU reception");
     // A strong non-wifi interference is generated on RU 2 during PSDU reception
-    bandInfo.fc = (m_frequency + (m_channelWidth / 4)) * 1e6;
-    bandInfo.fl = bandInfo.fc - ((m_channelWidth / 4) * 1e6);
-    bandInfo.fh = bandInfo.fc + ((m_channelWidth / 4) * 1e6);
+    bandInfo.fc = MHzToHz(m_frequency + (m_channelWidth / 4));
+    bandInfo.fl = bandInfo.fc - MHzToHz(m_channelWidth / 4);
+    bandInfo.fh = bandInfo.fc + MHzToHz(m_channelWidth / 4);
     bands.clear();
     bands.push_back(bandInfo);
 
     Ptr<SpectrumModel> SpectrumInterferenceRu2 = Create<SpectrumModel>(bands);
     Ptr<SpectrumValue> interferencePsdRu2 = Create<SpectrumValue>(SpectrumInterferenceRu2);
-    *interferencePsdRu2 = interferencePower / ((m_channelWidth / 2) * 20e6);
+    *interferencePsdRu2 = interferencePower / (MHzToHz(m_channelWidth / 2) * 20);
 
     Simulator::Schedule(delay + MicroSeconds(50),
                         &TestUlOfdmaPhyTransmission::GenerateInterference,
@@ -4330,7 +4337,7 @@
                         MilliSeconds(100));
     ScheduleTest(delay,
                  true,
-                 (m_channelWidth >= 40)
+                 (m_channelWidth >= MHz_u{40})
                      ? WifiPhyState::IDLE
                      : WifiPhyState::CCA_BUSY, // PHY should move to CCA_BUSY if interference is
                                                // generated in its primary channel
@@ -4341,7 +4348,7 @@
                  1,
                  0); // Reception of the PSDU from STA 2 should have failed (since interference
                      // occupies RU 2)
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Generate an interference on the full band and verify that both solicited HE TB PPDUs have
@@ -4352,15 +4359,15 @@
                         "Reception of solicited HE TB PPDUs with interference on the full band "
                         "during PSDU reception");
     // A strong non-wifi interference is generated on the full band during PSDU reception
-    bandInfo.fc = m_frequency * 1e6;
-    bandInfo.fl = bandInfo.fc - ((m_channelWidth / 2) * 1e6);
-    bandInfo.fh = bandInfo.fc + ((m_channelWidth / 2) * 1e6);
+    bandInfo.fc = MHzToHz(m_frequency);
+    bandInfo.fl = bandInfo.fc - MHzToHz(m_channelWidth / 2);
+    bandInfo.fh = bandInfo.fc + MHzToHz(m_channelWidth / 2);
     bands.clear();
     bands.push_back(bandInfo);
 
     Ptr<SpectrumModel> SpectrumInterferenceAll = Create<SpectrumModel>(bands);
     Ptr<SpectrumValue> interferencePsdAll = Create<SpectrumValue>(SpectrumInterferenceAll);
-    *interferencePsdAll = interferencePower / (m_channelWidth * 20e6);
+    *interferencePsdAll = interferencePower / (MHzToHz(m_channelWidth) * 20);
 
     Simulator::Schedule(delay + MicroSeconds(50),
                         &TestUlOfdmaPhyTransmission::GenerateInterference,
@@ -4379,7 +4386,7 @@
         1,
         0); // Reception of the PSDU from STA 2 should have failed (since interference occupies RU
             // 2)
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Send another HE TB PPDU (of another UL MU transmission) on RU 1 and verify that both
@@ -4404,7 +4411,7 @@
     uint32_t succ;
     uint32_t fail;
     uint32_t bytes;
-    if (m_channelWidth > 20)
+    if (m_channelWidth > MHz_u{20})
     {
         // One PSDU of 1001 bytes should have been successfully received from STA 2 (since
         // interference from STA 3 on distinct 20 MHz channel)
@@ -4431,7 +4438,7 @@
                  succ,
                  fail,
                  bytes);
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Send another HE TB PPDU (of another UL MU transmission) on RU 2 and verify that both
@@ -4453,7 +4460,7 @@
                         0,
                         false);
     // Expected figures from STA 1
-    if (m_channelWidth > 20)
+    if (m_channelWidth > MHz_u{20})
     {
         // One PSDU of 1000 bytes should have been successfully received from STA 1 (since
         // interference from STA 3 on distinct 20 MHz channel)
@@ -4471,7 +4478,7 @@
     }
     ScheduleTest(delay,
                  true,
-                 (m_channelWidth >= 40)
+                 (m_channelWidth >= MHz_u{40})
                      ? WifiPhyState::IDLE
                      : WifiPhyState::CCA_BUSY, // PHY should move to CCA_BUSY instead of IDLE if HE
                                                // TB PPDU on primary channel
@@ -4482,7 +4489,7 @@
                  1,
                  0); // Reception of the PSDU from STA 2 should have failed (since interference from
                      // STA 3 on same 20 MHz channel)
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Send an HE SU PPDU during 400 ns window and verify that both solicited HE TB PPDUs have been
@@ -4510,7 +4517,7 @@
         0,
         1,
         0); // Reception of the PSDU from STA 2 should have failed (since interference from STA 3)
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Only send a solicited HE TB PPDU from STA 2 on RU 2 and verify that it has been correctly
@@ -4525,7 +4532,7 @@
                         &TestUlOfdmaPhyTransmission::CheckPhyState,
                         this,
                         m_phySta3,
-                        (m_channelWidth >= 40)
+                        (m_channelWidth >= MHz_u{40})
                             ? WifiPhyState::IDLE
                             : WifiPhyState::CCA_BUSY); // PHY should move to CCA_BUSY instead of
                                                        // IDLE if HE TB PPDU on primary channel
@@ -4541,7 +4548,7 @@
                  false,
                  Seconds(0),
                  WifiPhyState::RX); // Measurement channel is total channel width
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Measure the power of a solicited HE TB PPDU from STA 2 on RU 2
@@ -4549,12 +4556,12 @@
                         &TestUlOfdmaPhyTransmission::LogScenario,
                         this,
                         "Measure power for reception of HE TB PPDU only on RU 2");
-    auto rxPower =
-        DbmToW(19); // 16+1 dBm at STAs and +2 at AP (no loss since all devices are colocated)
+    auto rxPower = DbmToW(
+        dBm_u{19}); // 16+1 dBm at STAs and +2 at AP (no loss since all devices are colocated)
     SchedulePowerMeasurementChecks(delay,
-                                   (m_channelWidth >= 40) ? 0.0 : rxPower,
+                                   (m_channelWidth >= MHz_u{40}) ? Watt_u{0.0} : rxPower,
                                    rxPower, // power detected on RU1 only if same 20 MHz as RU 2
-                                   0.0,
+                                   Watt_u{0.0},
                                    rxPower);
     ScheduleTest(delay,
                  true,
@@ -4568,7 +4575,7 @@
                  false,
                  Seconds(0),
                  WifiPhyState::RX); // Measurement channel is total channel width
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Measure the power of a solicited HE TB PPDU from STA 2 on RU 2 with power spectrum density
@@ -4584,23 +4591,24 @@
                         &TestUlOfdmaPhyTransmission::SetPsdLimit,
                         this,
                         m_phySta2,
-                        3.0);
+                        dBm_per_MHz_u{3});
 
-    rxPower = (m_channelWidth > 40)
-                  ? DbmToW(19)
-                  : DbmToW(18.0103); // 15.0103+1 dBm at STA 2 and +2 at AP for non-OFDMA
-                                     // transmitted only on one 20 MHz channel
+    rxPower = (m_channelWidth > MHz_u{40})
+                  ? DbmToW(dBm_u{19})
+                  : DbmToW(dBm_u{18.0103}); // 15.0103+1 dBm at STA 2 and +2 at AP for non-OFDMA
+                                            // transmitted only on one 20 MHz channel
     auto rxPowerOfdma = rxPower;
-    if (m_channelWidth <= 40)
+    if (m_channelWidth <= MHz_u{40})
     {
-        rxPowerOfdma = (m_channelWidth == 20)
-                           ? DbmToW(14.0309)  // 11.0309+1 dBm at STA and +2 at AP if 106-tone RU
-                           : DbmToW(18.0103); // 15.0103+1 dBm at STA 2 and +2 at AP if 242-tone RU
+        rxPowerOfdma =
+            (m_channelWidth == MHz_u{20})
+                ? DbmToW(dBm_u{14.0309})  // 11.0309+1 dBm at STA and +2 at AP if 106-tone RU
+                : DbmToW(dBm_u{18.0103}); // 15.0103+1 dBm at STA 2 and +2 at AP if 242-tone RU
     }
     SchedulePowerMeasurementChecks(delay,
-                                   (m_channelWidth >= 40) ? 0.0 : rxPower,
+                                   (m_channelWidth >= MHz_u{40}) ? Watt_u{0.0} : rxPower,
                                    rxPower, // power detected on RU1 only if same 20 MHz as RU 2
-                                   0.0,
+                                   Watt_u{0.0},
                                    rxPowerOfdma);
 
     // Reset PSD limitation once HE TB has been sent
@@ -4608,7 +4616,7 @@
                         &TestUlOfdmaPhyTransmission::SetPsdLimit,
                         this,
                         m_phySta2,
-                        100.0);
+                        dBm_per_MHz_u{100});
     ScheduleTest(delay,
                  true,
                  WifiPhyState::IDLE,
@@ -4621,7 +4629,7 @@
                  false,
                  Seconds(0),
                  WifiPhyState::RX); // Measurement channel is total channel width
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Measure the power of 2 solicited HE TB PPDU from both STAs
@@ -4629,10 +4637,12 @@
                         &TestUlOfdmaPhyTransmission::LogScenario,
                         this,
                         "Measure power for reception of HE TB PPDU on both RUs");
-    rxPower = DbmToW(19); // 16+1 dBm at STAs and +2 at AP (no loss since all devices are colocated)
+    rxPower = DbmToW(
+        dBm_u{19}); // 16+1 dBm at STAs and +2 at AP (no loss since all devices are colocated)
     const auto rxPowerNonOfdma =
-        (m_channelWidth >= 40) ? rxPower
-                               : rxPower * 2; // both STAs transmit over the same 20 MHz channel
+        (m_channelWidth >= MHz_u{40})
+            ? rxPower
+            : rxPower * 2; // both STAs transmit over the same 20 MHz channel
     SchedulePowerMeasurementChecks(delay, rxPowerNonOfdma, rxPowerNonOfdma, rxPower, rxPower);
     ScheduleTest(delay,
                  true,
@@ -4643,7 +4653,7 @@
                  1,
                  0,
                  1001); // One PSDU of 1001 bytes should have been successfully received from STA 2
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Verify that an HE TB PPDU from another BSS has been correctly received (no UL MU transmission
@@ -4670,7 +4680,7 @@
                         this);
 
     Simulator::Schedule(delay + MilliSeconds(500), &TestUlOfdmaPhyTransmission::Reset, this);
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     //---------------------------------------------------------------------------
     // Verify that two solicited HE TB PPDUs with delay (< 400ns) between the two signals have been
@@ -4702,7 +4712,7 @@
                  1001, // One PSDU of 1001 bytes should have been successfully received from STA 2
                  true,
                  NanoSeconds(200));
-    delay += Seconds(1.0);
+    delay += Seconds(1);
 
     Simulator::Run();
 }
@@ -4710,26 +4720,26 @@
 void
 TestUlOfdmaPhyTransmission::DoRun()
 {
-    m_frequency = 5180;
-    m_channelWidth = 20;
+    m_frequency = MHz_u{5180};
+    m_channelWidth = MHz_u{20};
     m_expectedPpduDuration = NanoSeconds(292800);
     NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
     RunOne();
 
-    m_frequency = 5190;
-    m_channelWidth = 40;
+    m_frequency = MHz_u{5190};
+    m_channelWidth = MHz_u{40};
     m_expectedPpduDuration = NanoSeconds(163200);
     NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
     RunOne();
 
-    m_frequency = 5210;
-    m_channelWidth = 80;
+    m_frequency = MHz_u{5210};
+    m_channelWidth = MHz_u{80};
     m_expectedPpduDuration = NanoSeconds(105600);
     NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
     RunOne();
 
-    m_frequency = 5250;
-    m_channelWidth = 160;
+    m_frequency = MHz_u{5250};
+    m_channelWidth = MHz_u{160};
     m_expectedPpduDuration = NanoSeconds(76800);
     NS_LOG_DEBUG("Run UL OFDMA PHY transmission test for " << m_channelWidth << " MHz");
     RunOne();
@@ -4738,10 +4748,10 @@
 }
 
 /**
- * \ingroup wifi-test
- * \ingroup tests
+ * @ingroup wifi-test
+ * @ingroup tests
  *
- * \brief PHY padding exclusion test
+ * @brief PHY padding exclusion test
  */
 class TestPhyPaddingExclusion : public TestCase
 {
@@ -4756,10 +4766,10 @@
 
     /**
      * Send HE TB PPDU function
-     * \param txStaId the ID of the TX STA
-     * \param index the RU index used for the transmission
-     * \param payloadSize the size of the payload in bytes
-     * \param txDuration the duration of the PPDU
+     * @param txStaId the ID of the TX STA
+     * @param index the RU index used for the transmission
+     * @param payloadSize the size of the payload in bytes
+     * @param txDuration the duration of the PPDU
      */
     void SendHeTbPpdu(uint16_t txStaId,
                       std::size_t index,
